function load_trainset_cb(listfile,color,imgw,imgh)

global TrainData;

TrainData = [];
fprintf('loading images from %s ...', listfile);
TrainData.imgfilenames = load_text(listfile);
imgcell = load_images(TrainData.imgfilenames);
TrainData.nimgs = length(imgcell);
fprintf(' read %d images. DONE.\n', TrainData.nimgs);

TrainData.imgw = imgw;
TrainData.imgh = imgh;

%do sampling, range shifting, color conversion, etc
if color
	TrainData.I_size = [imgw imgh 3];
	TrainData.I = massageImgCell(imgcell, TrainData.I_size, 0, 1, 0, 2^16-1);
else
	TrainData.I_size = [imgw imgh];
	TrainData.I = massageImgCell(imgcell, [TrainData.I_size 1], 0, 1, 0, 2^16-1);
end

%subtract off the mean
TrainData.I_orig = TrainData.I;
TrainData.mu = mean(TrainData.I')';
TrainData.I = TrainData.I - repmat(TrainData.mu,1,TrainData.nimgs);

% GUI stuff from here to end
clf(figure(1));
colormap(gray(1024));
build_menu;
for i = 1:TrainData.nimgs
	subplot(121); 
		image(imgcell{i}); 
		title(sprintf('Original [%d/%d]',i, TrainData.nimgs));
		set(gca, 'XTick', 0);
		set(gca, 'YTick', 0);
	subplot(122); 
		show_vectimg(TrainData.I_orig(:,i),TrainData.I_size);
		%if color, image(reshape(TrainData.I(:,i), TrainData.I_size));
		%else imagesc(reshape(TrainData.I(:,i), TrainData.I_size));
		%end
		title(sprintf('Resampled [%d/%d]',i, TrainData.nimgs));
	drawnow;
	pause(1/25);
end


