function load_testset_cb(listfile);

global TrainData;
global TestData;

TestData = [];
fprintf('loading images from %s ...', listfile);
TestData.imgfilenames = load_text(listfile);
imgcell = load_images(TestData.imgfilenames);
TestData.nimgs = length(imgcell);
fprintf(' read %d images. DONE.\n', TestData.nimgs);

TestData.imgw = TrainData.imgw;
TestData.imgh = TrainData.imgh;

color = (ndims(TrainData.I_size) == 3);

%do sampling, range shifting, color conversion, etc
if color
	TestData.I_size = [TestData.imgw TestData.imgh 3];
	TestData.I = massageImgCell(imgcell, TestData.I_size, 0, 1, 0, 2^16-1);
else
	TestData.I_size = [TestData.imgw TestData.imgh];
	TestData.I = massageImgCell(imgcell, [TestData.I_size 1], 0, 1, 0, 2^16-1);
end

%subtract off the (training set) mean
TestData.I_orig = TestData.I;
TestData.I = TestData.I - repmat(TrainData.mu,1,TestData.nimgs);

% GUI stuff from here to end
clf(figure(1));
colormap(gray(1024));
build_menu;

nr = round(sqrt(TestData.nimgs));
nc = ceil(TestData.nimgs/nr);
subplot(111);
idx = 1;
for i=1:TestData.nimgs
	subplot(nr,nc,idx);
	show_vectimg(TestData.I_orig(:,i), TestData.I_size);
	idx = idx + 1;
end


