function morph_two_cb()

global TrainData;
global Model;
global GUI;

mainW = figure(1);
clf(mainW);
colormap(gray(1024));
build_menu;
mwPos = get(mainW, 'Position');
mwWidth = mwPos(3);
mwHeight = mwPos(4);

strw = 130;
strh = 20;

%
% Get first image
%
texth = uicontrol(mainW, 'Style', 'text', 'Position', [mwWidth/2-(strw/2) mwHeight-strh-5 strw strh], ...
                  'String', 'Select first image');
nr = round(sqrt(TrainData.nimgs));
nc = ceil(TrainData.nimgs/nr);
idx = 1;
for i=1:TrainData.nimgs
	subplot(nr,nc,idx);
	ih = show_vectimg(TrainData.I_orig(:,i), TrainData.I_size);
	set(ih,'ButtonDownFcn', sprintf('select_img_cb(%d);',i));
	idx = idx + 1;
end

%wait for selection
GUI.select_idx = -1;
while GUI.select_idx == -1
	pause(0.25);
end
idx1 = GUI.select_idx;

set(texth, 'String', 'Select second image');

%wait for selection
GUI.select_idx = -1;
while GUI.select_idx == -1
	pause(0.25);
end
idx2 = GUI.select_idx;

fprintf('Performing morph of %d and %d\n', idx1, idx2);

Im = morph_two_images(TrainData.I(:,idx1), TrainData.I(:,idx2), 0.5);
Im = Im + Model.mu;

clf(mainW);
colormap(gray(1024));
build_menu;

subplot(131); show_vectimg(TrainData.I_orig(:,idx1), TrainData.I_size); %axis equal; axis tight;
subplot(132); show_vectimg(TrainData.I_orig(:,idx2), TrainData.I_size); %axis equal; axis tight;
subplot(133); show_vectimg(Im, TrainData.I_size); %axis equal; axis tight;

slidew = 300;
slideh = 30;

slidepos = [mwWidth/2-(slidew/2) 30 slidew slideh];
slider = uicontrol(mainW, 'Style', 'slider', 'Position', slidepos, 'Min', 0, 'Max', 1, 'Value', 0.5); 

val = get(slider,'Value');
while 1
	%fprintf('morping mode...\n');
	newval = get(slider,'Value');
	if newval ~= val
		val = newval;
		%fprintf('GOT NEW VALUE (%f)!\n',val);
		Im = morph_two_images(TrainData.I(:,idx1), TrainData.I(:,idx2), val);
		Im = Im + Model.mu;
		subplot(133); show_vectimg(Im, TrainData.I_size); %axis equal; axis tight;
	end
	pause(0.3);
end


