function [S, S_size] = resample_img(I, factor)

method = 'linear';

I_size = size(I);
color = (ndims(I_size) == 3);
S_size = round(I_size(1:2)*factor);
if color, S_size(3) = 3; end

%if the image size doesn't change don't resample!
if sum(S_size(1:2) == I_size(1:2)) == 2
	S = I;
	S_size = I_size;
	return;
end

x = 1:I_size(1);
y = 1:I_size(2);
xi = linspace(1,I_size(1),S_size(1));
yi = linspace(1,I_size(2),S_size(2));

S = zeros(S_size);
if color
	for i=1:3
		S(:,:,i) = interp2(y,x',I(:,:,i),yi,xi',method);
	end
else
	S = interp2(y,x',I,yi,xi',method);
end


